Autodesk官方最新的.NET教程(六)(C#版)

转载 2008年05月03日 18:00:00

在本章中,我们将介绍.NET API的用户界面部分能做些什么。我们首先将介绍一个自定义上下文菜单(快捷菜单)。接下来我们将实现一个无模式可停靠的面板(一个真正的AutoCAD增强辅助窗口)来支持拖放操作。接着我们将介绍通过模式窗体选取实体。最后,我们将介绍使用AutoCAD的选项对话框来设置雇员的缺省值。

本章还会介绍和上面内容有关的API。

第一部分 自定义上下文菜单

到目前为止,我们所写的代码只与CommandMethod属性定义的命令行进行相互操作。一个AutoCAD .NET程序能通过一个特殊的类来实现装载时的初始化工作。这个类只要实现IExtensionApplication .NET接口并暴露一个组件级别的属性(此属性把类定义为ExtensionApplication),就可以响应一次性的装载和卸载事件。例子:

[assembly: ExtensionApplication(typeof(Lab6_CS.AsdkClass1))]

   public class AsdkClass1 : IExtensionApplication

   {

1) 现在修改AsdkClass1类来实现上面的接口。要实现这个接口,你必须实现Initialize() 和Terminate()函数。因为我们要实现的是一个接口,而接口中的函数总是定义为纯虚拟的。

      public void Initialize()

      {

         AddContextMenu();

         EmployeeOptions.AddTabDialog();

      } 

     

      public void Terminate()

      {

      }

为了加入自定义上下文菜单,我们必须定义一个‘ContextMenuExtension’类的成员。这个类位于Autodesk.AutoCAD.Windows命名空间中。

要使用ContextMenuExtension,我们必须使用new关键字来进行初始化,给必要的属性赋值,并调用Application.AddDefaultContextMenuExtension()。上下文菜单的工作方式是:对于每个菜单条目,我们定义一个成员函数来处理菜单单击事件。我们可能通过.NET的代理来实现。我们使用C#关键字+=和-=确定让哪个函数来处理事件。请尽快熟悉这种设计模式,因为在C#中会使用很多。

2) 添加一个‘ContextMenuExtension’成员变量和下面两个用来添加和移除自定义菜单的函数。请好好研究一下代码来看看究竟发生了什么。

      void AddContextMenu()

      {

         try

         {

            m_ContextMenu = new ContextMenuExtension();

            m_ContextMenu.Title = "Acme Employee Menu";

            Autodesk.AutoCAD.Windows.MenuItem mi;

            mi = new Autodesk.AutoCAD.Windows.MenuItem("Create Employee");

            mi.Click +=  new EventHandler(CallbackOnClick);

            m_ContextMenu.MenuItems.Add(mi);

           

            Autodesk.AutoCAD.ApplicationServices.Application.AddDefaultContextMenuExtension(m_ContextMenu);

         }

         catch

         {

         }

      }

      void RemoveContextMenu()

      {

         try

         {

            if( m_ContextMenu != null )

            {

               Autodesk.AutoCAD.ApplicationServices.Application.RemoveDefaultContextMenuExtension(m_ContextMenu);

                m_ContextMenu = null;

            }

         }

         catch

         {

         }

      }

注意我们在代码中使用了‘CallbackOnClick’函数。我们希望这个函数(我们现在还没有定义)响应菜单项选择事件。在我们的例子中,我们想要做的是调用我们的成员函数‘Create()’。请加入下面的代码。

      void CallbackOnClick(object Sender, EventArgs e)

      {

         Create();

      }

现在,从Initialize()中调用AddContextMenu()函数,同样地,请在Terminate()中调用RemoveContextMenu()。

请运行代码。使用NETLOAD来装载编译好的组件,然后在AutoCAD的空白处右击……你应该可以看到’Acme‘快捷菜单了。如果失败了,明明你做的都是正确的……为什么呢?

通常,AutoCAD的数据是存储在文档中的,而访问实体的命令有权修改文档。当我们运行代码来响应上下文菜单单击事件,我们是从命令结构的外部来访问文档。当我们调用的代码尝试通过添加一个雇员来修改文档时,我们就碰到了错误。正确的做法是必须锁住文档,这可以通过使用Document.LockDocument()命令来实现。

3) 修改CallbackOnClick来锁住文档:

      void CallbackOnClick(object Sender, EventArgs e)

      {

         DocumentLock docLock = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.LockDocument();

         Create();

         docLock.Dispose();

      }

注意,我们保留了一个‘DocumentLock’对象的拷贝。要把文档解锁,我们只要销毁这个DocumentLock对象。

再次运行代码。现在应该可以看到快捷菜单了。

第2部分 无模式对话框、可进行拖放的可停靠面板

为了使我们的用户界面和AutoCAD实现无缝链接,我们要尽可能在所有的地方使用同样的用户界面结构。这会使应用程序看起来与AutoCAD结合的很好,并有效地减少代码的重复。一个很好的例子是AutoCAD中的可停靠面板。

使用.NET API,我们可以创建一个简单的窗体并把它放到面板中。我们可以实例化一个自定义的‘PaletteSet’对象来包含窗体,并可以把这个PaletteSet定义成我们喜欢的样式。

4) 在解决方案浏览器中通过右击工程来添加一个用户控件。给它命名为ModelessForm。使用控件工具箱,加入如下所示的编辑框和标签控件。

<!--[if !vml]--><!--[endif]-->

使用属性窗口设置三个编辑框的属性。设置如下:

<首先是最上面的编辑框>

(Name)    = tb_Name

Text = <请输入一个名字>

<第二个编辑框>

(Name) = tb_Division

Text = Sales

<第三个编辑框>

(Name) = tb_Salary

Text = <请输入薪水>

要使用.NET API实例化一个面板对象,你必须要实例化用户控件对象(无模式窗体)和‘PaletteSet’对象。调用PaletteSet的成员函数Add来传递用户控件对象。

5) 接下来,我们要加入一个命令来创建面板。在类中加入一个名为CreatePalette的函数和CommandMethod属性来定义名为“PALETTE”的命令。

请看一下下面的代码块。这是实例化面板的代码。

ps = new Autodesk.AutoCAD.Windows.PaletteSet("Test Palette Set");

ps.MinimumSize = new System.Drawing.Size(300, 300);

System.Windows.Forms.UserControl myCtrl = new ModelessForm();

ps.Add("test", myCtrl);

ps.Visible = true;

6) 把上面的代码加入到CreatePalette()函数。‘ps’需要在函数的外部声明:

      private Autodesk.AutoCAD.Windows.PaletteSet ps;

在函数的实例化面板代码之前加入检查ps是否为null的代码。

编译并运行工程。在AutoCAD中装载组件,运行‘PALETTE’命令来检查面板是否被装载。

使用PaletteSet.Style来看看PaletteSetStyles对象。例如:

ps.Style = PaletteSetStyles.ShowTabForSingle;

我们也可以试试诸如透明性的属性,例如:

   ps.Opacity = 90;

注意:要使用PaletteSet 和PaletteSetStyles对象,你必须加入两个命名空间Autodesk.AutoCAD.Windows和Autodesk.AutoCAD.Windows.Palette

在我们继续之前,让我们执行一个快速的维护更新:请在AsdkClass1类中加入下列成员:

      public static string sDivisionDefault = "Sales";

      public static string sDivisionManager = "Fiona Q. Farnsby";

这些值将被用作为部门和部门经理的缺省值。由于它们被声明为’static’,它们在每个程序中只实例化一次,并在组件装载的时候实例化。

第2a部分 在无模式窗体中加入拖放支持

在这部分,我们将加入允许我们使用面板窗体中编辑框的值来创建一个雇员。当用户从面板中拖动到AutoCAD中,将会提示输入职位,一个新的雇员实体将使用这些值来进行创建。

7) 为了支持拖放,我们首先需要一个对象来进行拖动。在编辑框的下面,另外加入一个名为Label4的标签控件,设置标签的文本为一些提示性的东西(‘Drag to Create Employee’)。通过这个标签,我们可以在AutoCAD中处理拖放。

要捕捉到什么时候拖动事件发生,我们必须要知道什么时候鼠标开始操作。

首先,我们要在类的构造函数中注册事件,代码如下:

         Label4.MouseMove += new System.Windows.Forms.MouseEventHandler(Label4_MouseMove);

8) 在ModelessForm类中加入下面的函数声明:

      private void Label4_MouseMove( object sender, System.Windows.Forms.MouseEventArgs e)

      {

         if (System.Windows.Forms.Control.MouseButtons == System.Windows.Forms.MouseButtons.Left)

         {

            // start dragDrop operation, MyDropTarget will be called when the cursor enters the AutoCAD view area.

            Autodesk.AutoCAD.ApplicationServices.Application.DoDragDrop(this, this, System.Windows.Forms.DragDropEffects.All, new MyDropTarget());

         }

      }

通常事件处理器有2个输入参数,一个object类的sender和与事件有关的参数。对于MouseMove,我们也要做同样的事情。

运行这个工程,检查一下当鼠标经过文本的时候,函数是否被调用的。

我们还可以进一步知道是不是按了鼠标左键:

         if (System.Windows.Forms.Control.MouseButtons == System.Windows.Forms.MouseButtons.Left)

         {

         }

我们需要一个方法来检测什么时候对象被拖入到AutoCAD。我们可以使用.NET的基类DropTarget来实现。要使用它,你只要创建从这个基类派生的类并实现你想要的函数。在我们这个例子中,我们需要的是OnDrop()。

9) 在工程中加入一个从Autodesk.AutoCAD.Windows.DropTarget派生的类‘MyDropTarget’。如果你把这个类加入到ModelessForm.cs文件中,请把这个类加入到ModelessForm类之后。

      override public void OnDrop(System.Windows.Forms.DragEventArgs e)

    {

}

在这个函数中,我们最后会调用AsdkClass1的成员CreateDivision() 和CreateEmployee,传入ModelessForm类中的编辑框的值。要实现这个功能,我们需要一个方法来连接ModelessForm实例。最佳的方法是通过DragEventArgs。但首先我们要把鼠标事件连接到MyDropTarget类。

10) 加入下面的代码到鼠标左键(MouseButtons.Left)处理函数中:

   Autodesk.AutoCAD.ApplicationServices.Application.DoDragDrop(this, this, System.Windows.Forms.DragDropEffects.All, new MyDropTarget());

注意我们传入’this’两次。第一次是用于Control参数,第二次是用于传入用户自定义数据。因为我们传入的是ModelessForm 类的实例,所以我们可以在放下的时候使用它来获取编辑框的值。

11) 回到OnDrop处理函数,让我们使用参数来调用创建雇员的函数。首先,添加职位提示的代码。在AsdkClass1.Create()中已经有相关的代码了,位于‘Get Employees Coordinates…’.注释下面。添加此代码来提示输入职位。

12) 接下来,获取传入到DragEventArgs 参数的ModelessForm对象:

         ModelessForm ctrl = (ModelessForm)e.Data.GetData(typeof(ModelessForm));

请注意一下怎样通过typeof关键字把参数强制转化为ModelessForm的实例。

13) 使用上面的实例来调用AsdkClass1成员:

         AsdkClass1.CreateDivision(ctrl.tb_Division.Text, AsdkClass1.sDivisionManager);

         AsdkClass1.CreateEmployee(ctrl.tb_Name.Text, ctrl.tb_Division.Text, Convert.ToDouble(ctrl.tb_Salary.Text), prPosRes.Value);

注意:AsdkClass1的方法要不通过AsdkClass1的实例来调用,那么方法必须被声明为’ public static’。因为public static 方法只能调用其它的public static 方法,你需要修改几个AsdkClass1类中的方法为’ public static’。请你进行相关的修改(应该至少有4项要修改)。

14) 最后,因为我们处理的事件位于AutoCAD命令之外,我们必须再次在会修改数据库的代码处锁住文档。请加入锁住文档的代码,加入的方法与前面的上下文菜单是一样的。

编译、装载并运行组件,使用PALETTE命令。你应该可以使用拖放操作来创建一个雇员了。

第三部分  从有模式窗体中选择实体

本章的以下部分将演示获取一个用户在屏幕上选择的雇员实例的详细信息,并把信息显示在一个有模式窗体的编辑框中。这部分的重点是创建一个有模式窗体,并在执行选择操作而窗体要失去焦点时隐藏它。为了获取雇员的详细信息,我们将使用第4章结束时给出的ListEmployee帮助函数。

首先,我们需要创建一个窗体类。这个类是一个真实的窗体而不是我们在ModelessForm中创建的用户控件。

15) 在工程中创建一个Windows窗体类。调用‘ModalForm’类。在窗体中加入以下所示的三个编辑框控件和标签控件以及两个按钮。

<!--[if !vml]--><!--[endif]-->

使用属性窗口来设置三个编辑框的属性。设置如下:

<首先是最上面的编辑框>

(Name)    = tb_Name

Text = <空白>

<第二个编辑框>

(Name) = tb_Division

Text = <空白>

<第三个编辑框>

(Name) = tb_Salary

Text = <空白>

<上部的按钮>

(Name)  = SelectEmployeeButton

Text = Select Employee

<下部的按钮>

(Name)  = Close

Text = Close

接下来创建按钮的事件处理函数。‘Close’按钮可以只简单地调用:

         this.Close();

要显示对话框,让我们在类中创建一个把窗体实例化为有模式对话框的命令函数。下面的实现的代码:

      [CommandMethod("MODALFORM")]

      public void ShowModalForm()

      {

         ModalForm modalForm = new ModalForm();

         Autodesk.AutoCAD.ApplicationServices.Application.ShowModalDialog(modalForm);

      }

编译、装载并在AutoCAD中运行MODALFORM命令来看看对话框是否可以工作。试试在对话框的右下角调整对话框的大小,然后关闭它。注意,重新使用MODALFORM命令时,对话框会出现在你上次离开的地方!这是ShowModalDialog方法的一个特征。大小和位置值被AutoCAD保存了。

 ‘Select Employee’按钮首先将执行一个简单的实体选择。这我们可以通过使用Editor.GetEntity()方法来实现,选择单一的实体比使用选择集来得方便的多。下面是怎样使用这个方法的代码:

            PromptEntityOptions prEnt = new PromptEntityOptions("Select an Employee");

            PromptEntityResult prEntRes = ed.GetEntity(prEnt);

16) 把上面的代码加入到SelectEmployeeButton_Click处理函数中,还要加入必需的数据库、命令行、事务处理设置变量和一个try catch块。不要忘了在finally块中销毁它们。

使用PromptStatus.OK来测试GetEntity的返回值,如果返回不等于,就调用this.Show并退出处理函数。

一旦我们获得的返回值是OK,那么我们就可以使用PromptEntityResult.ObjectId()方法来获取所选实体的object Id。这个id可以和一个固定的字符串数组被传入到AsdkClass1.ListEmployee函数中来获取雇员的详细信息。可以通过以下的代码说明:

         ArrayList saEmployeeList = new ArrayList();

            AsdkClass1.ListEmployee(prEntRes.ObjectId, saEmployeeList);

            if (saEmployeeList.Count == 4)

            {

                tb_Name.Text = saEmployeeList[0].ToString();

                tb_Salary.Text = saEmployeeList[1].ToString();

                tb_Division.Text = saEmployeeList[2].ToString();

            }

17) 加入上面的代码,它会在窗体的编辑框中显示雇员的详细信息。

在开始测试代码之前,我们还要记住的是代码是在有模式对话框中运行的,也就意味着当对话框可见的时候用户与AutoCAD的互操作是被禁止的。在用户能够进行选择雇员对象之前,我们必须隐藏窗体。当选择结束后,我们可以再次站窗体显示(例如,可以在finally块的函数中)

18) 在选择之前加入隐藏窗体的代码(例如在try块之前) ‘this.Hide’ 和选择结束后显示窗体的代码(例如,可以在finally块中)‘this.Show’。

编译、装载并在AutoCAD中运行MODALFORM命令来看看对话框是否工作。试试选择一个实体并填充窗体中编辑框的值。

第四部分 在AutoCAD选项对话框中加入页面

本章的最后部分将向你介绍如何定义一个用户控件,这个控件可以被作为一个页面显示在AutoCAD的选项对话框中。我们可以使用这个页面来设置程序运行期间的缺省值。在Employee例子中,我们只是在AsdkClass1类中简单地设置了sDivisionDefault 和sDivisionManager字符串。

19) 在工程中加入另外一个名为‘EmployeeOptions’的用户控件。在控件中加入两个编辑框和标签控件,如下图所示:

<!--[if !vml]--><!--[endif]-->

使用属性窗口来设置编辑框的属性,设置如下:

<上面的编辑框>

(Name)    = tb_EmployeeDivision

Text = <空白>

<下面的编辑框>

(Name) = tb_DivisionManager

Text = <空白>

使用.NET API来显示自定义多页对话框,需要两个步骤。首先,通过传入要调用的成员函数的地址,来知道什么时候选项对话框出现。其次是实现回调函数。传入到回调函数中的第二个参数是一个‘TabbedDialogEventArgs’对象,我们必须使用它来调用‘AddTab’函数。AddTab使用一个标题字符串和一个‘TabbedDialogExtension’对象的实例,此实例封装了我们的窗体(其实是用户控件)。在TabbedDialogExtension的构造函数中,我们输入窗体的实例和回调函数(OnOK, OnCancel 或OnHelp)的地址。

20) 在EmployeeOptions类中,加入一个名为AddTabDialog的public static函数,它会添加一个可供系统调用的事件处理:

      public static void AddTabDialog()

      {

         Autodesk.AutoCAD.ApplicationServices.Application.DisplayingOptionDialog += new TabbedDialogEventHandler(TabHandler);

       }

在AsdkClass1的Initialize函数中加入调用此函数的代码。因为这个函数是在程序启动的时候调用的(因为类已经实现了IExtensionApplication接口),所以多页对话框就被自动的加载。

20a) 实现一个相同的函数来移除事件处理,使用C#的-=关键字。

在这里,你可以看到我们为AutoCAD中的Application 对象的DisplayingOptionDialog事件加入了一个处理函数,此函数会调用‘TabHandler’函数。所以接下来我们要实现这个函数。

21) 加入下面的代码来实现处理函数:

      private static void TabHandler(object sender, Autodesk.AutoCAD.ApplicationServices.TabbedDialogEventArgs e)

      {

         EmployeeOptions EmployeeOptionsPage = new EmployeeOptions();

         e.AddTab("Acme Employee Options",

            new TabbedDialogExtension(

            EmployeeOptionsPage,

            new TabbedDialogAction(EmployeeOptionsPage.OnOk)));

      }

我们首先实例化了一个EmployeeOptions对象。然后调用e.AddTab(),在这个函数中传入了一个TabbedDialogExtension的实例。TabbedDialogExtension的构造函数使用了EmployeeOptionsPage实例和一个TabbedDialogAction对象。TabbedDialogAction对象的参数可以是Ok, Cancel 或Help回调函数。在这个函数中,我们使用的是OK。

22) 现在剩下的就是确定回调函数的内容,也就是ONOK的内容。前面已经说过了,我们只要设置AsdkClass1的static成员,也就是设置tb_DivisionManager 和tb_EmployeeDivision编辑框中的值。下面是代码:

      public void OnOk()

      {

         AsdkClass1.sDivisionDefault = tb_EmployeeDivision.Text;

         AsdkClass1.sDivisionManager = tb_DivisionManager.Text;

      }

编译、装载并选择AutoCAD的选项菜单项来看一下我们的自定义对话框。试试设置对话框中的值并实例化一个雇员。你可以使用PRINTOUTEMPLOYEE命令来查看详细信息。

附加的问题:怎样让对话框的编辑框能自动显示为AsdkClass1中的Manager和Division字符串的内容?

百度推广教程(六)

《网络营销师-SEM精品课265课》,网络营销思路、方法与实战攻略。
  • 2017年03月16日 09:36

Autodesk官方最新的.NET教程(七)(C#版)

第7章 事件本章将讨论AutoCAD中的事件。我们将介绍事件处理函数的使用,特别是监视AutoCAD命令的事件处理函数和监视被AutoCAD命令修改的对象的事件处理函数。在解释怎样在C#中实现Auto...
  • zenghf7878
  • zenghf7878
  • 2005-06-22 09:12:00
  • 3004

Autodesk官方最新的.NET教程(C#版)中文版-----附源代码

  • 2009年02月26日 22:33
  • 145KB
  • 下载

Autodesk官方最新的.NET教程(五)(C#版)

第 5 章 用户互操作:提示和选择背景提示通常包含一个描述性信息,伴随一个停止以让用户理解所给的信息并输入数据。数据可以通过多种方式被输入,如通过命令行、对话框或AutoCAD编辑窗口。给出的提示要遵...
  • zenghf7878
  • zenghf7878
  • 2005-06-13 14:46:00
  • 2230

Autodesk官方最新AutoCAD.net开发教程(C#版含代码)共8章

  • 2017年04月28日 19:21
  • 4.88MB
  • 下载

Autodesk官方最新的.NET教程(五)(C#版)

第 5 章 用户互操作:提示和选择背景提示通常包含一个描述性信息,伴随一个停止以让用户理解所给的信息并输入数据。数据可以通过多种方式被输入,如通过命令行、对话框或AutoCAD编辑窗口。给出的提示要遵...
  • sjzwl
  • sjzwl
  • 2007-10-23 20:11:00
  • 557

Autodesk官方最新的.NET教程(六)(C#版)

 第6章  更多的用户界面:添加自定义数据在本章中,我们将介绍.NET API的用户界面部分能做些什么。我们首先将介绍一个自定义上下文菜单(快捷菜单)。接下来我们将实现一个无模式可停靠的面板(一个真正...
  • zenghf7878
  • zenghf7878
  • 2005-06-21 10:21:00
  • 3586

Autodesk官方最新的.net教程(C#版)

  • 2011年11月30日 21:43
  • 200KB
  • 下载

Autodesk官方最新的.NET教程(二)(C#版)

第2章  .NET AutoCAD 向导及Editor类        在第一章中,我们使用的是类库模板,这样就不得不手工加入acdbmdg. dll 和acmgd.dll这两个引用。在这一章中,我们...
  • zenghf7878
  • zenghf7878
  • 2005-06-01 09:54:00
  • 3565

Autodesk官方最新的.NET教程(C#版)

  • 2008年07月29日 09:38
  • 324KB
  • 下载
收藏助手
不良信息举报
您举报文章:Autodesk官方最新的.NET教程(六)(C#版)
举报原因:
原因补充:

(最多只允许输入30个字)